/*
    rc_up Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "module/assemble.h"
#include "module/config.h"
#include "module/cmd.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
Assemble_t  assemble;
Assemble_CMD_t receive_cmd_assemble;

/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_rc_up(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / RC_UP_FREQ;

  osDelay(RC_UP_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
Assemble_Init(&assemble, &Config_GetRobotParam()->assemble, RC_UP_FREQ);
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
osMessageQueueGet(task_runtime.msgq.assmble.assmble_cmd, &receive_cmd_assemble, NULL, 0);

   Assemble_Update(&assemble);
   Assemble_Calc(&assemble,receive_cmd_assemble);
   Assemble_SetOutput(&assemble);

    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}